
	list      p=12F629            ; list directive to define processor
	#include <p12F629.inc>        ; processor specific variable definitions
        errorlevel -302			; suppress "register not in bank0, check page bits" message.	

	__config H'3F84' 


counter	equ 0x20

		org 0x0

start	goto Main

		org 0x04

		bcf INTCON,GPIF			; ACK (clear mismatch)
		btfss	GPIO,3			; Rising or falling ?
		goto falling
		btfss	GPIO,0			; A Rising, check B
		goto trescero
cerotres decf counter,f			; B leads A
		bcf GPIO,1
		bsf GPIO,5
falling	retfie					; Falling, discard
;falling	btfss	GPIO,0			; Falling, check B
		goto cerotres
trescero incf counter,f			; A leads B
		bsf GPIO,1
		bcf GPIO,5
		retfie

Main    clrf   	GPIO
        movlw   B'00000111'
        movwf   CMCON			; Select GPIO
		bsf STATUS,RP0 			; Bank 1
		call 3FFh 				; Get the cal value
		movwf OSCCAL 			; Calibrate
        movlw   B'00000110'		; Enable pull-ups, prescaler for TMR0=128
        movwf   OPTION_REG
        movlw   B'00011001'     ; GP1,2,5 = output, GP0,3,4 = input
        movwf	TRISIO
		movlw	B'00001000'		; enable int on change on GP3
		movwf	IOC
		bcf STATUS,RP0 			; Bank 0
        movlw   B'11001000'		; Enable ints
        movwf   INTCON
		movf GPIO,w				; Read GPIO for the first time
		clrf counter

loop:	
		goto loop


		END


